#!/usr/bin/perl -w
# perl FasNameChange.pl seq.fas list > out

use strict;
use warnings;

my $seqFile = "$ARGV[0]";
my $listFile = "$ARGV[1]";
my $name = "";
my $AccNum = "";
my $AccNum_seqFile = "";

my @listArray = ( );
my @seqArray = ( );
my  @accNumArray = ( );
my %nameHash = ( );

# name list を読み込む
open(LIST,"$listFile");
@listArray = <LIST>;
close LIST;

# seq list を読み込む
open(SEQ,"$seqFile");
@seqArray = <SEQ>;
close SEQ;

# name と accession number をハッシュに格納する．
foreach my $line (@listArray) {
  chomp($line);
  ($name,$AccNum) = split(/\t/,$line);
  $nameHash{$AccNum} = $name;
  push(@accNumArray,$AccNum);
}


foreach my $seqFileLine (@seqArray){
  chomp($seqFileLine);
  if($seqFileLine =~ /^>/){
    $seqFileLine =~ s/^>//g;
    $seqFileLine =~ s/\s.*?$//g;
    $AccNum_seqFile = $seqFileLine;
    if(grep/$AccNum_seqFile/,@accNumArray){
      print ">$nameHash{$AccNum_seqFile}\_$AccNum_seqFile\n";     
    }else{
      print ">NONE\_$AccNum_seqFile\n";
    }
  } else {
    print "$seqFileLine\n";
  }
}

